/* the checker has three arguments:
    - first - name of the input file
    - second - name of the correct output file
    - third - name of the contestant output file */
#include<iostream>
#include<fstream>
#include<math.h>
#define MAXN 500
#define MAXM 500
using namespace std;
void output_message (double points, string message) {
    cout << points << endl ;
    cerr << message << endl ;
    exit(0);
}
static const int base=15313,mod=57173;
int main (int argc, char** argv) {
    ifstream inp,ans,out;
    if (argc<4) output_message(0,"The checker needs input file, correct output and contestant output!");
    inp.open(argv[1]);
    if (inp.is_open()==false) output_message(0,"Could not open input file!");
    out.open(argv[3]);
    if (out.is_open()==false) output_message(0,"Could not open contestant output file!");

    int s,n;
    long long int hash1=0;
    if (!(inp >> s >> n )) output_message(0,"Error reading input file!");
    hash1*=base; hash1+=n;
    for (int i=0; i<n-1; i++) {
        int x,y;
        if (!(inp >> x >> y)) output_message(0,"Error reading input file!");
        hash1*=base; hash1+=x; hash1%=mod;
        hash1*=base; hash1+=y; hash1%=mod;
    }
    int hash2;
    if (!(out >> hash2 )) output_message(0,"Error reading output file!");
    if (hash1!=hash2) output_message(0,"Invalid output file!");
    int status;
    if (!(out >> status )) output_message(0,"Error reading output file!");
    if (status==-1) output_message(0,"Too many questions!");
    if (status==-2) output_message(0,"Protocol violation!");
    if (status==-3) output_message(0,"Wrong answer!");
    if (status!=0) output_message(0,"Invalid output file!");
    int cnt;
    if (!(out >> cnt )) output_message(0,"Error reading output file!");

    if ((s==0)||(s==1)||(s==2)) output_message(1,"OK! Questions: "+to_string(cnt));
    if (s==3) {
        if (cnt<=10000) output_message(1,"OK! Questions: "+to_string(cnt));
        else if (cnt<=15000) output_message(min(1.0,1000./(cnt-9000)),"OK! Questions: "+to_string(cnt));
        else output_message(0.1,"OK! Questions: "+to_string(cnt));
    }
    else if (s==4) {
        if (cnt<=50000) output_message(1,"OK! Questions: "+to_string(cnt));
        else if (cnt<=200000) output_message(min(1.0,25000./(cnt-25000)),"OK! Questions: "+to_string(cnt));
        else output_message(0.1,"OK! Questions: "+to_string(cnt));
    }
    else {
        if (cnt<=170) output_message(1,"OK! Questions: "+to_string(cnt));
        else if (cnt<=1000) output_message(min(1.0,pow((170.+3000.)/(cnt+3000),3000./cnt)),"OK! Questions: "+to_string(cnt));
        else if (cnt<=20000) output_message(min(0.5,pow(170./cnt,0.4)),"OK! Questions: "+to_string(cnt));
        else output_message(0.1,"OK! Questions: "+to_string(cnt));
    }
    return 0;
}
