/* test generator uses testlib.h: https://github.com/MikeMirzayanov/testlib/blob/master/testlib.h
   arguments:
    - first - name of the test that will be generated
    - second - subtask number
    - third - value of n
    - fourth - height of tree
    - fifth - minimum size of level
    - sixth - constant for controlling the tree
    - seventh - constant for controlling the topological sorting
    - eighth, ninth, tenth, ... - used for seed for registerGen */
#include "testlib.h"
#include<iostream>
#include<vector>
#include "test_generator.h"
#define MAXN 1000
vector <int> a[MAXN];
int newname[MAXN];
int cnt;
vector <char> find_brackets (vector <char>& brackets, int balance, int left, int code) {
    if ((left==0)&&(balance==0)) {
        if (cnt++==code) return brackets;
        else return {};
    }
    if (left!=0) {
        brackets.push_back(+1);
        auto res=find_brackets(brackets,balance+1,left-1,code);
        if (res.size()!=0) return res;
        brackets.pop_back();
    }
    if ((balance>1)||((balance==1)&&(left==0))) {
        brackets.push_back(-1);
        auto res=find_brackets(brackets,balance-1,left,code);
        if (res.size()!=0) return res;
        brackets.pop_back();
    }
    return {};
}
int main (int argc, char** argv) {
    if (argc==1) {
       cout << "The test generator needs arguments!\n";
       return 0;
    }
    check_tests(argc,argv);
    if (argc<7) {
       cout << "The test generator needs more arguments!\n";
       return 0;
    }
    registerGen(argc,argv,1);
    ofstream fout(argv[1]);
    int s=atoll(argv[2]),n=atoll(argv[3]);
    int h=atoll(argv[4]),minl=atoll(argv[5]),t1=atoll(argv[6]);
    int t2=atoll(argv[7]);


    vector <int> perm(n);
    for (int i=0; i<n; i++) {
        perm[i]=i;
    }
    shuffle(perm.begin(),perm.end());
    if (h<=n-1) {
        auto parts=rnd.partition(h,n-1,minl);
        parts.insert(parts.begin(),1);
        int prv=0;
        for (int i=0; i<h; i++) {
            shuffle(perm.begin()+prv,perm.begin()+prv+parts[i]);
            for (int j=prv+parts[i]; j<prv+parts[i]+parts[i+1]; j++) {
                int parent=perm[rnd.wnext(prv,prv+parts[i]-1,t1)];
                a[parent].push_back(perm[j]);
            }
            prv+=parts[i];
        }
    }
    else {
        vector <char> brackets;
        brackets.reserve(2*n);
        auto res=find_brackets(brackets,0,n,h-n);
        vector <int> opened;
        opened.reserve(n);
        int ind=0;
        for (auto b : res) {
            if (b==+1) {
                if (ind!=0) a[opened.back()].push_back(perm[ind]);
                opened.push_back(perm[ind++]);
            }
            else opened.pop_back();
        }
        /*for (int i=0; i<n; i++) {
            int curr=perm[i];
            for (auto to : a[curr]) {
                cout << curr+1 << " " << to+1 << endl ;
            }
        }*/
    }

    vector <int> top;
    top.reserve(n);
    vector <int> nxt;
    nxt.reserve(n);
    nxt.push_back(perm[0]);
    for (int i=1; i<=n; i++) {
        int ind=rnd.wnext(0,((int)nxt.size())-1,t2);
        int curr=nxt[ind];
        top.push_back(curr);
        nxt.erase(nxt.begin()+ind);
        for (auto to : a[curr]) {
            nxt.push_back(to);
        }
    }
    for (int i=0; i<n; i++) {
        newname[top[i]]=i;
    }


    fout << s << endl << n << endl ;
    for (int i=0; i<n; i++) {
        int curr=perm[i];
        for (auto to : a[curr]) {
            fout << newname[curr]+1 << " " << newname[to]+1 << endl ;
        }
    }
    fout.close();

    cout << "test successfully generated!!!" << endl ;
    validate_test(argc,argv);
    return 0;
}
